
power = {}

power.buttonId = {}

function power:callbackMenu_main(what, axisComponent)
	elseif what == "POWER_TOGGLEFLIGHT" then
		Player.consoleCommandToggleFlightMode(g_currentMission.player)
		Player.onInputDebugFlyToggle(g_currentMission.player)
		power:updateControlsMenu()
	elseif what == "POWER_RUNSPEED" and axisComponent == -1 then
		g_currentMission.player.motionInformation.maxRunningSpeed = MathUtil.clamp(g_currentMission.player.motionInformation.maxRunningSpeed - 5, 2, 200)
		g_currentMission.player.motionInformation.maxCheatRunningSpeed = MathUtil.clamp(g_currentMission.player.motionInformation.maxCheatRunningSpeed - 5, 2, 200)
		power:updateControlsMenu()
	elseif what == "POWER_RUNSPEED" and axisComponent == 1 then
		g_currentMission.player.motionInformation.maxRunningSpeed = MathUtil.clamp(g_currentMission.player.motionInformation.maxRunningSpeed + 5, 2, 200)
		g_currentMission.player.motionInformation.maxCheatRunningSpeed = MathUtil.clamp(g_currentMission.player.motionInformation.maxCheatRunningSpeed + 5, 2, 200)
		power:updateControlsMenu()
	elseif what == "POWER_JUMPHEIGHT" and axisComponent == -1 then
		g_currentMission.player.motionInformation.jumpHeight = MathUtil.clamp(g_currentMission.player.motionInformation.jumpHeight - 1, 2, 50)
		power:updateControlsMenu()
	elseif what == "POWER_JUMPHEIGHT" and axisComponent == 1 then
		g_currentMission.player.motionInformation.jumpHeight = MathUtil.clamp(g_currentMission.player.motionInformation.jumpHeight + 1, 2, 50)
		power:updateControlsMenu()
	elseif what == "POWER_SUPERSTRENGTH" then
		Player.consoleCommandToggleSuperStrongMode(g_currentMission.player)
		Player.MAX_PICKABLE_OBJECT_MASS = 500 -- power can do more than 50!
		power:updateControlsMenu()
	elseif what == "POWER_FLIGHTHELP" then
	else
		Logging.warning("Unknown menuCallback: " .. tostring(what))
	end
end

function power:updateControlsMenu()
	-- Remove all of our actions
	for key, eventId in pairs(power.buttonId) do
		g_inputBinding:removeActionEvent(eventId)
		power.buttonId[key] = nil
	end

	local textEnabled = g_i18n:getText("fieldJob_active")
	local textDisabled = g_i18n:getText("ui_production_status_inactive")

	local stateFlightMode = textDisabled
	local stateSuperStrength = textDisabled
	local stateRunningSpeed
	if g_addCheatCommands then
		stateRunningSpeed = g_currentMission.player.motionInformation.maxCheatRunningSpeed
	else
		stateRunningSpeed = g_currentMission.player.motionInformation.maxRunningSpeed
	end

	if g_flightModeEnabled then stateFlightMode = textEnabled end
	if g_currentMission.player.superStrengthEnabled then stateSuperStrength = textEnabled end

	local actions = {
		{ "POWER_TOGGLEHUD", "callbackMenu_main", g_i18n:getText("power_menu_toggleHUD"), 5 }
	}

	if g_currentMission.controlledVehicle == nil then
		table.insert(actions, { "POWER_TOGGLEFLIGHT", "callbackMenu_main", g_i18n:getText("power_menu_toggleFlight") .. " (" .. stateFlightMode .. ")", 6 })
		table.insert(actions, { "POWER_RUNSPEED", "callbackMenu_main", g_i18n:getText("power_menu_runSpeed") .. " (" .. stateRunningSpeed .. ")", 7 })
		table.insert(actions, { "POWER_JUMPHEIGHT", "callbackMenu_main", g_i18n:getText("power_menu_jumpHeight") .. " (" .. g_currentMission.player.motionInformation.jumpHeight .. ")", 7 })
		table.insert(actions, { "POWER_SUPERSTRENGTH", "callbackMenu_main", g_i18n:getText("power_menu_superStrength") .. " (" .. stateSuperStrength .. ")", 6 })
		if g_flightModeEnabled then
			table.insert(actions, { "POWER_FLIGHTHELP", "callbackMenu_main", g_i18n:getText("power_menu_flightHelp"), 7 })
		end
	end

	for _, item in ipairs(actions) do
		local _, eventId = nil
		if power.buttonId[item[3]] == nil then -- Skip if menu item already exists.. even though it shouldn't
			_, eventId = g_inputBinding:registerActionEvent(InputAction[item[1]], power, power[item[2]], false, true, false, true)
			power.buttonId[item[3]] = eventId
			g_inputBinding:setActionEventActive(eventId, true)
			g_inputBinding:setActionEventText(eventId, item[3])
			g_inputBinding:setActionEventTextPriority(eventId, item[4])
			g_inputBinding:setActionEventTextVisibility(eventId, true)
		end
	end
end

function power:removeActionEvents()
	local g_inputBinding = g_inputBinding
	-- Remove all of our actions
	for key, eventId in pairs(power.buttonId) do
		g_inputBinding:removeActionEvent(eventId)
		power.buttonId[key] = nil
	end
end

addModEventListener(power)